{%- import "shuup/front/macros/category.jinja" as category_macros with context -%}

{% if request.is_ajax() %}
    {{ category_macros.render_product_list(supplier) }}
{% elif is_brick_and_mortar(supplier) %}
    <script>window.location.href = {{ url("shuup:discover-our-stores") }}</script>
{% else %}
    {% extends "shuup/front/base.jinja" %}
    {%- import "shuup/front/macros/general.jinja" as macros with context -%}

    {% block extrameta %}
    {{ macros.render_metadata(object, object.name, "", "website") }}
    <link rel="stylesheet" href="{{ static('shuup_multivendor/vendor.css') }}">
    {% endblock %}

    {% block title %}{{ object.name }}{% endblock %}

    {% block content_title %}{% endblock %}

    {% block breadcrumb %}
        {% call macros.breadcrumb() %}
            {{ macros.render_breadcrumb_item("/", _("Home")) }}
            {{ macros.render_breadcrumb_item(url('shuup:supplier_list'), _("Brands")) }}
            {{ macros.render_breadcrumb_item(None, object.name, True) }}
        {% endcall %}
    {% endblock %}

    {% macro render_products_section(supplier) %}
        <h2 class="mb-6"><span>{% trans %}Shop from{% endtrans %}</span> {{ supplier.name }}</h2>
        {# TODO: filtering
        {{ category_macros.render_product_filters_toggle() }}
        #}
        {{ category_macros.render_product_list(supplier) }}
    {% endmacro %}

    {% macro render_about(vendor) %}
        {% if vendor.description %}
            <div class="my-5">
                <button class="custom-accordion__toggle-btn collapsed"
                        type="button"
                        data-toggle="collapse"
                        data-target="#vendor-about-accordion"
                        aria-expanded="false"
                        aria-controls="vendor-about-accordion">
                    <h3>{% trans %}About{% endtrans %}</h3>
                    <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                    <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                </button>
                <div class="collapse" id="vendor-about-accordion">
                    <div class="vendor-accordion-content">
                        <p>{{ vendor.description|safe_vendor_description }}</p>
                    </div>
                </div>
            </div>
        {% endif %}
    {% endmacro %}

    {% macro render_brand_statement(vendor) %}
        {% if vendor.canvas_supplier %}
            <div class="my-5">
                <button class="custom-accordion__toggle-btn collapsed"
                        type="button"
                        data-toggle="collapse"
                        data-target="#vendor-brand-accordion"
                        aria-expanded="false"
                        aria-controls="vendor-brand-accordion">
                    <h3>{% trans %}Brand Statement{% endtrans %}</h3>
                    <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                    <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                </button>
                <div class="collapse" id="vendor-brand-accordion">
                    <div class="vendor-accordion-content">
                        <p>{{ vendor.canvas_supplier.brand_statement|safe_vendor_description }}</p>
                    </div>
                </div>
            </div>
        {% endif %}
    {% endmacro %}

    {% macro render_contact_info(vendor) %}
        {% if vendor.contact_address %}
            {% set vendor_address = ", ".join(get_vendor_address_lines(vendor.contact_address)) %}
            <div class="my-5">
                <button class="custom-accordion__toggle-btn collapsed"
                        type="button"
                        data-toggle="collapse"
                        data-target="#vendor-contactinfo-accordion"
                        aria-expanded="false"
                        aria-controls="vendor-contactinfo-accordion">
                    <h3>{% trans %}Contact info{% endtrans %}</h3>
                    <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                    <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                </button>
                <div class="collapse" id="vendor-contactinfo-accordion">
                    <div class="vendor-accordion-content">
                        <p>{{ vendor_address }}</p>
                    </div>
                </div>
            </div>
        {% endif %}
    {% endmacro %}

    {% macro render_instagram_handle(vendor) %}
        {% if vendor.canvas_supplier and vendor.canvas_supplier.social_media_handles %}

        {% set handles = get_all_handles(vendor.canvas_supplier.social_media_handles) %}
            {% if handles %}
                <div class="my-5">
                    <button class="custom-accordion__toggle-btn collapsed"
                            type="button"
                            data-toggle="collapse"
                            data-target="#vendor-instagram-accordion"
                            aria-expanded="false"
                            aria-controls="vendor-instagram-accordion">
                        <h3>{% trans %}Instagram{% endtrans %}</h3>
                        <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                            <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                            <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                        </svg>
                        <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                            <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                        </svg>
                    </button>
                    <div class="collapse" id="vendor-instagram-accordion">
                        <div class="vendor-accordion-content">
                            <p>
                            {% for handle in handles %}
                                <a href="http://instagram.com/{{ no_at_handle(handle) }}">{{ handle }}</a>&nbsp;
                            {% endfor %}
                            </p>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endif %}
    {% endmacro %}

    {% macro render_location_info(vendor) %}
        {% if vendor.contact_address %}
            {% set vendor_address = ", ".join([vendor.contact_address.city, vendor.contact_address.region_code]) %}
            <div class="my-5">
                <button class="custom-accordion__toggle-btn collapsed"
                        type="button"
                        data-toggle="collapse"
                        data-target="#vendor-location-accordion"
                        aria-expanded="false"
                        aria-controls="vendor-location-accordion">
                    <h3>{% trans %}Location{% endtrans %}</h3>
                    <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                    <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                </button>
                <div class="collapse" id="vendor-location-accordion">
                    <div class="vendor-accordion-content">
                        <p>{{ vendor_address }}</p>
                    </div>
                </div>
            </div>
        {% endif %}
    {% endmacro %}

    {% macro render_opening_hours(vendor) %}
        {% set opening_hours = render_vendor_opening_hours(vendor) %}
        {% if opening_hours %}
            <div class="my-5">
                <button class="custom-accordion__toggle-btn collapsed"
                        type="button"
                        data-toggle="collapse"
                        data-target="#vendor-openinghours-accordion"
                        aria-expanded="false"
                        aria-controls="vendor-openinghours-accordion">
                    <h3>{% trans %}Opening Hours{% endtrans %}</h3>
                    <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                    <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                </button>
                <div class="collapse" id="vendor-openinghours-accordion">
                    <div class="vendor-accordion-content">
                        {{ opening_hours }}
                    </div>
                </div>
            </div>
        {% endif %}
    {% endmacro %}

    {% macro render_sdgs(vendor) %}
        {% if vendor.canvas_supplier and vendor.canvas_supplier.sustainability_goals %}
            <div class="my-5">
                <button class="custom-accordion__toggle-btn collapsed"
                        type="button"
                        data-toggle="collapse"
                        data-target="#vendor-sdgs-accordion"
                        aria-expanded="false"
                        aria-controls="vendor-sdgs-accordion">
                    <h3>{% trans %}Sustainability Goals{% endtrans %}</h3>
                    <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                    <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                    </svg>
                </button>
                <div class="collapse" id="vendor-sdgs-accordion">
                    <div class="vendor-accordion-content">
                        <div class="vendor-sdg-row">
                            {% for sdg in vendor.canvas_supplier.sustainability_goals.all()|sort(attribute='id') %}
                                <div class="vendor-sdg">
                                    <button type="button" class="vendor-sdg__btn" data-container="body" data-toggle="popover" data-placement="top" title="{{ sdg.name }}" data-content="{{ sdg.description }}" data-trigger="focus">
                                        {% if sdg.image %}
                                            <img src="{{ sdg.image.url }}">
                                        {% else %}
                                            {{ sdg.name }}
                                        {% endif %}
                                    </button>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
    {% endmacro %}

    {% macro render_vendor_info_section(vendor) %}
        <div class="vendor-info">
            <div class="flex-row">
                <div class="col vendor-accordion-col">
                    <div class="vendor-accordion-col__content">
                        <div class="vendor-name">
                            <h1>{{ vendor.name }}</h1>
                        </div>
                        {% if render_favorite_button() %}
                            {% from "shuup_multivendor/supplier/favorites_macro.jinja" import render_profile_favorite_button %}
                            {{ render_profile_favorite_button(vendor.pk, is_favorite_vendor(vendor))}}
                        {% endif %}
                        {{ render_brand_statement(vendor) }}
                        {{ render_sdgs(vendor) }}
                        {{ render_location_info(vendor) }}
                        {{ render_instagram_handle(vendor) }}
                    </div>
                </div>
                <div class="col vendor-images-col">
                    <div class="vendor-images-col__content">
                        {% if vendor.logo %}
                            <div class="vendor-logo">
                                <img src="{{ vendor.logo|thumbnail(size=(500, 500), upscale=True) }}" class="img-responsive" />
                            </div>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
        <hr class="my-6">
    {% endmacro %}

    {% block content %}
        <script>window.PRODUCT_LIST_FILTERS = {{ form.fields.keys()|list|json }};</script>
        <div class="supplier-view">
            {% placeholder "brand_header" %}{% endplaceholder %}
            {{ render_vendor_info_section(supplier) }}
            {% placeholder "brand_center" %}{% endplaceholder %}
            {{ render_products_section(supplier) }}
            {% placeholder "brand_footer" %}{% endplaceholder %}
        </div>
    {% endblock %}

    {% block extra_content %}
        {# TODO: filtering
        {{ category_macros.render_product_filters() }}
        #}
    {% endblock %}

    {% block extrajs %}
        {{ category_macros.render_extrajs() }}
        <script src="{{ shuup_static('shuup_multivendor/vendor.js', 'shuup-multivendor') }}"></script>
    {% endblock %}
{% endif %}
